DECLARE SUB fazface (i%)
DEFINT A-Z
TYPE tipodalinha                      ' Definicao de user types
    X AS INTEGER                   ' Para conter os dados das
    y AS INTEGER                   ' linhas em uma so matriz
    Z AS INTEGER
    X1 AS INTEGER
    Y1 AS INTEGER
    Z1 AS INTEGER
    cor AS INTEGER
END TYPE

'Dimensionamento das variaveis usadas no programa, que sao:
'Pontos = dados das linhas
'Xn e Yn = dados das linhas depois de rotacionadas
'datadaface$ = dados das faces (pontos da face e cor) pegos no arquivo
'Xi, Yi, Xe e Ye = matriz onde ficam as posicoes das linhas ja desenhadas
'X, Y e Z = matriz maior para todos os pontos
'Ponteiros 1 e 2 e R = matrizes que dizem quais pontos devem ser rodados
'Cosseno& e Seno& = matrizes para tabela de seno e cosseno
'zmdp = matriz para os pontos medios de Z de cada face
'dat$ = matriz temporaria para os dados lidos do arquivo
'odp = matriz que guarda a ordem das faces para desenha-las corretamente
'posz = matriz que guarda as posicoes Z dos pontos
DIM SHARED Pontos(100) AS tipodalinha, Xn(100), Yn(100), datadaface$(100)
DIM SHARED Xi(100), Yi(100), Xf(100), Yf(100)
DIM X(100), y(100), Z(100), Ponteiros1(100), Ponteiros2(100)
DIM R(100), Cosseno&(360), Seno&(360)
DIM zmdp(100), dat$(100), odp(100), posz(100)

' Loop que controi uma tabela de senos e cossenos
' os valores sao multiplicados por uma constante para que nao
' tenham pontos decimais, o que deixa mais devagar
FOR A! = 0 TO 359 / 57.29577951# STEP 1 / 57.29577951#
    Cosseno&(A) = INT(.5 + COS(A!) * 1024)
    Seno&(A) = INT(.5 + SIN(A!) * 1024): A = A + 1
NEXT

' Loop que abre o arquivo e pega os dados dele
' os dados estao na forma:
' linhas:              -=> serve para indicar que aqui comecao as linhas!
' X,Y,Z,X1,Y1,Z1,cor,  -=> onde:
'                          X,Y,Z = cordenas do pnt inicial da linha
'                          X1,Y1,Z1 = cordenas do pnt final da linha
'                          cor = cor da linha! (tem que ser <> 15)
' fdl                  -=> "Fim Das Linhas" indica que nao tem + linhas!
' faces:               -=> serve para indicar que aqui comecao as faces!
' P1,P2,P3,...,Pn,cor, -=> onde:
'                          P1-Pn = Pontos da face, cor = cor da face!
' fdf                  -=> "Fim Das Faces" indica que nao tem + faces!
OPEN "CUBOF.G3D" FOR INPUT AS #1
LINE INPUT #1, header$
IF header$ <> "G Soft 3D file" THEN              'Se a primeira linha do
  PRINT "Nao e um aruivo G Soft 3D compativel."  'arquivo nao for
  END                                            'G Soft 3D file entao sai
END IF
DO WHILE NOT EOF(1)
  LINE INPUT #1, lin$
  IF lin$ = "linhas:" THEN
    lt = 0
    DO WHILE NOT EOF(1)
      LINE INPUT #1, lin$
      IF lin$ = "fdl" THEN EXIT DO
      lt = lt + 1
      campo = 1
      FOR i = 1 TO LEN(lin$)
        char$ = MID$(lin$, i, 1)
        IF char$ = "," THEN
          campo = campo + 1
          GOTO pula
        END IF
        var$(campo) = var$(campo) + char$
pula:
      NEXT i
      Pontos(lt).X = VAL(var$(1))
      Pontos(lt).y = VAL(var$(2))
      Pontos(lt).Z = VAL(var$(3))
      Pontos(lt).X1 = VAL(var$(4))
      Pontos(lt).Y1 = VAL(var$(5))
      Pontos(lt).Z1 = VAL(var$(6))
      Pontos(lt).cor = VAL(var$(7))
      FOR i = 1 TO 7
        var$(i) = ""
      NEXT i
    LOOP
  END IF
  IF lin$ = "faces:" THEN
    ft = 0
    DO WHILE NOT EOF(1)
      LINE INPUT #1, lin$
      IF lin$ = "fdf" GOTO sai
      ft = ft + 1
      datadaface$(ft) = lin$
    LOOP
  END IF
LOOP
sai:
CLOSE #1

'Variavel que guarda o numero total de linhas
Numerodelinhas = lt

'Loop que guarda todos os pontos (iniciais e finais) em uma matriz maior
Np = 1
FOR A = 1 TO Numerodelinhas
    X(Np) = Pontos(A).X
    y(Np) = Pontos(A).y
    Z(Np) = Pontos(A).Z
    Np = Np + 1
    X(Np) = Pontos(A).X1
    y(Np) = Pontos(A).Y1
    Z(Np) = Pontos(A).Z1
    Np = Np + 1
NEXT

'Loop que cria dois "Ponteiros" que indicam para cada um
'dos pontos iniciais e finais de cada linha
FOR A = 1 TO Numerodelinhas
    Xs = Pontos(A).X
    Ys = Pontos(A).y
    Zs = Pontos(A).Z
    FOR B = 0 TO Np
        IF X(B) = Xs AND y(B) = Ys AND Z(B) = Zs THEN
            Ponteiros1(A) = B
            EXIT FOR
        END IF
    NEXT
    Xs = Pontos(A).X1
    Ys = Pontos(A).Y1
    Zs = Pontos(A).Z1
    FOR B = 0 TO Np
        IF X(B) = Xs AND y(B) = Ys AND Z(B) = Zs THEN
            Ponteiros2(A) = B
            EXIT FOR
        END IF
    NEXT
NEXT

'Agora precisamos de uma lista dos pontos que devemos rodar
'pois por exemplo: temos duas linhas assim:
'
' 1 o--------o 2 e 3     Como voce pode ver, os pontos 2 e 3
'            |           sao iguais, entao pra que rodar os dois?
'            |           Com essa tabela que estamos fazendo
'            |           eliminamos um(ou mais) dos dois(ou mais)
'            |           pontos iguais!
'            o 4

Nr = 1
FOR A = 1 TO Numerodelinhas
    F1 = Ponteiros1(A)
    S1 = Ponteiros2(A)
    IF Nr = 0 THEN
        R(Nr) = F1: Nr = Nr + 1
    ELSE
        Achado = 0
        FOR B = 1 TO Nr
            IF R(B) = F1 THEN
                Achado = -1: EXIT FOR
            END IF
        NEXT
        IF NOT Achado THEN R(Nr) = F1: Nr = Nr + 1
    END IF
        
    Achado = 0
    FOR B = 1 TO Nr
        IF R(B) = S1 THEN
            Achado = -1: EXIT FOR
        END IF
    NEXT
    IF NOT Achado THEN R(Nr) = S1: Nr = Nr + 1
NEXT

Vs = 1: Ds = 0

'Ang 1 e 2 sao os angulos de rotacao
'D 1 e 2 sao os deltas para rotacao em cada quadro
Ang1 = 0: Ang2 = 0: D1 = 0: D2 = 0

'Tlpos = posicao da tela
'Minhapos = posicao do usuario
'Sao usados nas rotinas de perspectiva
Tlpos = -250: Minhapos = 0

'Mx, My e Mz = coordenadas do usuario
'Ox, Oy e Oz = coordenadas do objeto
Mx = 0: My = 0: Mz = 0: Ox = 0: Oy = 0: Oz = -260

' Loop principal
DO
 SWAP Vs, Ds                                'faz a troca entre a tela vista
 SCREEN 9, , Ds, Vs                         'e a tela que foi desenhada

 Ang1 = (Ang1 + D1) MOD 360                 '- Atualiza o valor dos angulos
 Ang2 = (Ang2 + D2) MOD 360                 'de acorde com seus deltas

 IF Ang1 < 0 THEN Ang1 = Ang1 + 360         '- Ajusta os angulo se passarem
 IF Ang2 < 0 THEN Ang2 = Ang2 + 360         'de 0 ou de 360

 C1& = Cosseno&(Ang1): S1& = Seno&(Ang1)    '- Acha o Seno e o Cosseno dos
 C2& = Cosseno&(Ang2): S2& = Seno&(Ang2)    'novos angulo
 
 X = Speed: y = 0: Z = 0
 
 X1 = (X * C1&) \ 1024                      '- Agora ajustamos as
 Y1 = (X * S1&) \ 1024                      'coordenadas do objeto baseado
 X2 = (X1 * C2&) \ 1024                     'na sua velocidade
 Zn = (X1 * S2&) \ 1024
 Ox = Ox + X2: Oy = Oy + Y1: Oz = Oz + Zn
 IF Oz > 32000 THEN Oz = 32000
 IF Oz < -32000 THEN Oz = -32000
 IF Ox > 32000 THEN Ox = 32000
 IF Ox < -32000 THEN Ox = -32000
 IF Oy > 32000 THEN Oy = 32000
 IF Oy < -32000 THEN Oy = -32000
  
 IF centralizar THEN                         '- Se centralizar for = a 1
  Mx = Mx + (Ox - Mx) \ 4                    'entao o auto-center esta ligado
  My = My + (Oy - My) \ 4
  Mz = Mz + ((Oz + 200) - Mz) \ 4
 ELSE                                        '- Se nao, ajustamos a posicao
  Mz = Mz + Mzm                              'do usuario baseado na sua
  Mx = Mx + Mxm                              'velocidade
  My = My + Mym
  IF Mz > 32000 THEN Mz = 32000
  IF Mz < -32000 THEN Mz = -32000
  IF Mx > 32000 THEN Mx = 32000
  IF Mx < -32000 THEN Mx = -32000
  IF My > 32000 THEN My = 32000
  IF My < -32000 THEN My = -32000
 END IF

 WAIT &H3DA, 8                               '- Espera pelo redesenhamento
                                             'vertical da tela, usado para
                                             'acabar com o "flickering"
   
 LINE (xmin, ymin)-(xmax, ymax), 0, BF       '- Desenha um quadrado preto e
                                             'fechado para apagar o desenho
                                             'anterior
   
 p2 = 0
 nz = 0
 FOR A = 1 TO Nr                                   '- Roda os pontos
  R = R(A): Xo = X(R): Yo = y(R): Zo = Z(R)
  aaa = INT(R / 2) + 1
  X1 = (Xo * C1& - Yo * S1&) \ 1024
  Y1& = (Xo * S1& + Yo * C1&) \ 1024 - My + Oy
  X1& = (X1 * C2& - Zo * S2&) \ 1024 - Mx + Ox
  Zn = (X1 * S2& + Zo * C2&) \ 1024 - Mz + Oz
  IF A > 8 GOTO pulla
  posz(aaa) = Zn                                   '- Guarda a cordenada Z de
                                                   'cada pontos para depois
                                                   'poder calcular qual esta
                                                   'mais atras para desenhar
                                                   'as faces
pulla:
  IF (Minhapos - Zn) < 15 THEN
   Xn(R) = -1: Yn(R) = 0: Zn = 0                   '- Se o ponto estiver muito
                                                   'proximo (ou atras) do
                                                   'usuario entao nao o
                                                   'desenhamos
  ELSE
   V = (1330& * (Tlpos - Zn)) \ (Minhapos - Zn)        '- Caso contrario
   Xn(R) = 320 + X1& + (-X1& * V) \ 1330               'colocamos o objeto
   Yn(R) = 175 + (8 * (Y1& + (-Y1& * V) \ 1330)) \ 10  'em perspectiva
  END IF
 NEXT A

 xmax = 0: xmin = 10000: ymax = 0: ymin = 10000        '- Reseta os valores
                                                       'para poderem ser
                                                       'recalculados

 IF Ds = 1 THEN
  Ln = 1
  FOR A = 1 TO Numerodelinhas                          '- Loop que desenha
   F1 = Ponteiros1(A): S1 = Ponteiros2(A)              'as linhas
   Xn = Xn(F1): Yn = Yn(F1)
   IF Xn <> -1 THEN                                    '- Se Xn = -1 entao
    IF Xn(S1) <> -1 THEN                               'a linha esta fora
     X1 = Xn(S1): Y1 = Yn(S1)                          'do campo de visao
     LINE (X1, Y1)-(Xn, Yn), Pontos(A).cor             '- Desenha a linha
     IF X1 > xmax THEN xmax = X1                       '- Guarda os valores
     IF X1 < xmin THEN xmin = X1                       'maximos e minimos
     IF Y1 > ymax THEN ymax = Y1                       'para poder apagar
     IF Y1 < ymin THEN ymin = Y1
     Xi(Ln) = X1: Yi(Ln) = Y1                          '- Guarda os valores
     Xf(Ln) = Xn: Yf(Ln) = Yn                          'das linhas para o
                                                       'calculo das faces
     Ln = Ln + 1
    END IF
   END IF
  NEXT A
 ELSE
  Ln = 1
  FOR A = 1 TO Numerodelinhas
   F1 = Ponteiros1(A): S1 = Ponteiros2(A)
   Xn = Xn(F1): Yn = Yn(F1)
   IF Xn <> -1 THEN
    IF Xn(S1) <> -1 THEN
     X1 = Xn(S1): Y1 = Yn(S1)
     LINE (X1, Y1)-(Xn, Yn), Pontos(A).cor
     IF X1 > xmax THEN xmax = X1
     IF X1 < xmin THEN xmin = X1
     IF Y1 > ymax THEN ymax = Y1
     IF Y1 < ymin THEN ymin = Y1
     Xi(Ln) = X1: Yi(Ln) = Y1
     Xf(Ln) = Xn: Yf(Ln) = Yn
     Ln = Ln + 1
    END IF
   END IF
  NEXT A
 END IF
 xmax = xmax + 10: xmin = xmin - 10               '- Aumenta os valores
 ymax = ymax + 10: ymin = ymin - 10               'maximos e diminui os
                                                  'minimos em 10 para aumentar
                                                  'o quadrado preto,
                                                  'diminuindo a margem de
                                                  'erro

 FOR i = 1 TO ft                                  '- Loop que calcula o ponto
  cmp = 1                                         'medio das coordenadas Z
  td = 0                                          'de cada face
  FOR posic = 1 TO LEN(datadaface$(i))
   char$ = MID$(datadaface$(i), posic, 1)
   IF char$ = "," THEN
    td = td + 1
    cmp = cmp + 1
    GOTO aaki
   END IF
   dat$(cmp) = dat$(cmp) + char$
aaki:
  NEXT posic
  tp = td - 2
  FOR ii = 1 TO tp
   pa = VAL(dat$(ii))
   tzdp = tzdp + posz(pa)                         '- Soma-se todos os Zs da
  NEXT ii                                         'face o depois divide pelo
  zmdp(i) = tzdp / tp                             'total de Zs, achando o Z
  tzdp = 0                                        'medio de cada face
  FOR aa = 1 TO td
   dat$(aa) = ""                                  '- Reseta os valores de
  NEXT aa                                         'dat$ para serem usado de
 NEXT i                                           'novo

volta:                                       '- Loop que poem os pontos
 zmin = 10000                                'medios de Z (calculados
 FOR i = 1 TO ft                             'acima) em ordem de tras
  IF zmdp(i) < zmin THEN                     'para frente, para que
   IF pd(i) = 1 GOTO pulaa                   'sejam desenhados corretamente
   zmin = zmdp(i)
   ndzmin = i
  END IF
pulaa:
 NEXT i
 ooo = ooo + 1
 odp(ooo) = ndzmin                           '- Guarda o valor das faces em
 pd(ndzmin) = 1                              'ordem tras p/ frente
 ps = ps + 1
 IF ps < ft GOTO volta
 ps = 0
 ooo = 0


 FOR i = 1 TO ft                             '- Loop que desenha as faces
                                             'na ordem feita acima
  fazface odp(i)                             '- fazface e a sub que desenha
                                             'as faces
  odp(i) = 0                                 '- Reseta os valores para que
  pd(i) = 0                                  'sejam usados de novo
 NEXT i


 K$ = UCASE$(INKEY$)                         '- Atualiza os dados se alguma
 IF K$ <> "" THEN                            'tecla for pressionada
  SELECT CASE K$
   CASE "A"                                  'A = auto-center
    centralizar = NOT centralizar
   CASE "+"                                  '+ e - = zoom
    Mzm = Mzm + 2
   CASE "-"
    Mzm = Mzm - 2
   CASE "5"                                  '8,2,4 e 6 sao para movimentar
    Mxm = 0: Mym = 0: Mzm = 0                'o objeto, e 5 e para parar
   CASE "4"
    Mxm = Mxm - 2
   CASE "6"
    Mxm = Mxm + 2
   CASE "8"
    Mym = Mym - 2
   CASE "2"
    Mym = Mym + 2
   CASE "F"                                  'F = Acelerar
    Speed = Speed + 5
   CASE "B"                                  'B = Desacelerar
    Speed = Speed - 5
   CASE "C"                                  'C = Angulo inicial
    D1 = 0: D2 = 0
   CASE "S"                                  'S = Parar a rotacao
    Speed = 0
   CASE CHR$(0) + CHR$(72)                   'Setas = Controle de
    D1 = D1 + 1                              'rotacao
   CASE CHR$(0) + CHR$(80)
    D1 = D1 - 1
   CASE CHR$(0) + CHR$(75)
    D2 = D2 - 1
   CASE CHR$(0) + CHR$(77)
    D2 = D2 + 1
   CASE "Q", CHR$(27)                        'Q = Sair
    END
   CASE "V"                                  'V = posicao inicial
    D1 = 0: D2 = 0
    Ang1 = 0: Ang2 = 0
    Speed = 0
  END SELECT
 END IF
LOOP

SUB fazface (i)
REDIM dat$(102)
      cmp = 1
      FOR posic = 1 TO LEN(datadaface$(i))      '- Loop que le os dados das
        char$ = MID$(datadaface$(i), posic, 1)  'faces
        IF char$ = "," THEN
          td = td + 1
          cmp = cmp + 1
          GOTO aki
        END IF
        dat$(cmp) = dat$(cmp) + char$
aki:
      NEXT posic
      preenc = VAL(dat$(td))                    '- Guarda o valor da cor de
      dat$(td) = ""                             'preenchimento e reseta
      tp = td - 1                               '- Tp e o total de pontos
      pp1 = VAL(dat$(1))                        '- pp1 e o primeiro ponto
      FOR aa = 1 TO tp
        pp = VAL(dat$(aa))
        ppp = VAL(dat$(aa + 1))
        IF aa < tp THEN                                  '- Desenha o poligono
          LINE (Xf(pp), Yf(pp))-(Xf(ppp), Yf(ppp)), 15   'com borda 15 para
        ELSE                                             'ser pintado
          LINE (Xf(pp), Yf(pp))-(Xf(pp1), Yf(pp1)), 15
        END IF
        txp = txp + Xf(pp)                         '- Soma todos os x e
        typ = typ + Yf(pp)                         'todos os y da face
      NEXT aa
      pxdp = txp / tp                              '- Divide a soma acima
      pydp = typ / tp                              'pelo total de pontos
                                                   'achando o ponto central
                                                   'da face

      PAINT (pxdp, pydp), preenc, 15               '- Pinta a face no seu
                                                   'ponto central

      IF POINT(639, 1) <> 0 THEN CLS               '- Unica forma que achei
                                                   'para corrigir quando
                                                   'o PAINT pinta toda a
                                                   'tela!
ppulaa:
      pp1 = VAL(dat$(1))
      FOR aa = 1 TO tp
        pp = VAL(dat$(aa))
        ppp = VAL(dat$(aa + 1))
        dat$(aa) = ""
        IF aa < tp THEN                            '- Redesenha as linhas em
                                                   'cima das de cor 15 com
                                                   'seus valores originais
          LINE (Xf(pp), Yf(pp))-(Xf(ppp), Yf(ppp)), Pontos(pp).cor
        ELSE
          LINE (Xf(pp), Yf(pp))-(Xf(pp1), Yf(pp1)), Pontos(pp).cor
        END IF
      NEXT aa
      txp = 0: typ = 0: td = 0                     '- Reseta os valores para
                                                   'serem usados de novo
END SUB

